describe("FormController", function(){
	var widget, scope;

	var previousZeptoPhoneValue = Zepto.os.phone;

	var localStorageEngine, requestDataSourceEngine, SQLStorageStrategy, restEngine = {
		requestMetaData: function () {
			return Q.when({});
		}
	};

	var eventEngine = new EventEngine(new EventFactory(new MethodBuilder({}, {
		/*jslint evil: true */
		$eval: function(a, b) {
			/*jslint evil: true*/
			return eval(a, b);
		}
	}), {}), new EventHandler({}, {}, console), {
		updateTemplate: function() {}
	}, {
		i18n: function(text) {
			return text;
		}
	}, {
		logEvent: function() {}
	});

	beforeEach(inject(function(_$rootScope_) {
		var $scope = _$rootScope_;
		scope = $scope;
		var container = metaDataFactory.containerFactory(formContainer);
		$scope.widget = container.widgets[0];
		var formController = new FormController($scope, eventEngine);
		widget = $scope.widget;
	}));

	var aclEngine = new AclEngine();

	var screenService = {
		isPopupOpen: function () {
			return false;
		}
	};


	var metaDataFactory = new MetaDataFactory(localStorageEngine, requestDataSourceEngine,
		SQLStorageStrategy, restEngine, eventEngine, screenService, aclEngine, {
			project: {}
		}, new ZhUtil({}), Q, {
			getDataSourceLazy: function () {}
		});

	var formContainer =	{
		"id": "154704342142507206061259",
		"name": "signupInit",
		"label": "Informações básicas",
		"showFooter": true,
		"showHeader": true,
		"showMenu": true,
		"showBack": true,
		"showForm": true,
		"footer": "component/footer.html",
		"template": "container/window.html",
		"events": [],
		"widgets": [
			{
				"id": "77818280732323444341260",
				"name": "signupInit",
				"label": "Cadastros",
				"template": "widget/form.html",
				"orderFieldsBySequenceInForm": true,
				"isVisible": true,
				"actions": [],
				"dataSource": {
					"rest": false,
					"localStorage": true,
					"name": "/signupInit",
					"data": []
				},
				"events": [
					{
						"id": "7781828079009969361269",
						"name": "WidgetOnEnter",
						"code": "SignupInitController.onEnter(args.owner)"
					}
				],
				"fieldGroups": [
					{
						"id": "77818280740425318131270",
						"name": "ORG",
						"label": "Dados da organização",
						"collapsible": true,
						"opened": true
					},
					{
						"id": "77818280735090805031271",
						"name": "ADM",
						"label": "Dados do administrador",
						"collapsible": true,
						"opened": true
					}
				],
				"fields": [
					{
						"id": "77818280734383929351262",
						"name": "CREATIONORG",
						"label": "Data de fundação",
						"sequenceInForm": 2,
						"showOnForm": true,
						"placeholder": null,
						"isReadOnly": false,
						"isVisible": true,
						"fieldGroup": "ORG",
						"template": "field/date.html",
						"events": [],
						"class": "col-sm-6"
					},
					{
						"id": "7781828077321840201263",
						"name": "REGISTER",
						"label": "CPF/CNPJ",
						"sequenceInForm": 1,
						"placeholder": null,
						"showOnForm": true,
						"isReadOnly": false,
						"isVisible": true,
						"fieldGroup": "ORG",
						"template": "field/text-edit.html",
						"events": [],
						"class": "col-md-12"
					},
					{
						"id": "77818280717983132041264",
						"name": "ORGDESC",
						"label": "Descrição",
						"placeholder": null,
						"sequenceInForm": 3,
						"showOnForm": true,
						"isReadOnly": false,
						"isVisible": true,
						"fieldGroup": "ORG",
						"template": "field/textarea.html",
						"events": [],
						"class": "col-lg-12"
					},
					{
						"id": "77818280735347100081265",
						"name": "ADMINNAME",
						"label": "Nome",
						"placeholder": null,
						"isReadOnly": false,
						"showOnForm": true,
						"isVisible": true,
						"fieldGroup": "ADM",
						"sequenceInForm": 3,
						"template": "field/text-edit.html",
						"events": [],
						"class": "offset12"
					},
					{
						"id": "7781828071975223381266",
						"name": "ADMINEMAIL",
						"label": "Email",
						"showOnForm": true,
						"placeholder": null,
						"isReadOnly": false,
						"sequenceInForm": 2,
						"isVisible": true,
						"fieldGroup": "ADM",
						"template": "field/text-edit.html",
						"events": [],
						"class": 12
					},
					{
						"id": "77818280724580481491267",
						"name": "ADMINPASSWORD",
						"showOnForm": true,
						"label": "Senha",
						"placeholder": null,
						"sequenceInForm": 1,
						"isReadOnly": false,
						"isVisible": true,
						"fieldGroup": "ADM",
						"template": "field/password-edit.html",
						"events": [],
						"class": 6
					},
					{
						"id": "77818280719675849091268",
						"name": "CONFIRMPASSWORD",
						"showOnForm": true,
						"label": "Confirmar senha",
						"placeholder": null,
						"isReadOnly": false,
						"sequenceInForm": 4,
						"isVisible": true,
						"fieldGroup": "ADM",
						"template": "field/password-edit.html",
						"events": [],
						"class": 6
					}
				]
			}
		]
	};

	var formContainer2 =	{
		"id": "154704342142507206061259",
		"name": "signupInit",
		"label": "Informações básicas",
		"showFooter": true,
		"showHeader": true,
		"showMenu": true,
		"showBack": true,
		"showForm": true,
		"footer": "component/footer.html",
		"template": "container/window.html",
		"events": [],
		"widgets": [
			{
				"id": "77818280732323444341260",
				"name": "signupInit",
				"label": "Cadastros",
				"template": "widget/form.html",
				"isVisible": true,
				"actions": [],
				"dataSource": {},
				"events": [],
				"fieldGroups":[
					{
				  "id": "77818280740425318131270",
				  "name": "ORG",
				  "label": "Dados da organização",
				  "collapsible": true,
				  "opened": true
				}
				],
				"fields": [
					{
					"id": "77818280734383929351262",
					"name": "CREATIONORG",
					"label": "Data de fundação",
					"showOnForm": true,
					"placeholder": null,
					"isReadOnly": false,
					"isVisible": true,
					"template": "field/date.html",
					"events": [],
					"class": "col-sm-6"
				},
				{
					"id": "7781828077321840201263",
					"name": "REGISTER",
					"label": "CPF/CNPJ",
					"placeholder": null,
					"showOnForm": true,
					"isReadOnly": false,
					"isVisible": true,
					"template": "field/text-edit.html",
					"events": [],
					"class": "col-md-12"
				},
				{
					"id": "77818280717983132041264",
					"name": "ORGDESC",
					"label": "Descrição",
					"placeholder": null,
					"showOnForm": true,
					"isReadOnly": false,
					"isVisible": true,
					"template": "field/textarea.html",
					"events": [],
					"class": "col-lg-12"
				},
				{
					"id": "77818280735347100081265",
					"name": "ADMINNAME",
					"label": "Nome",
					"placeholder": null,
					"isReadOnly": false,
					"showOnForm": true,
					"isVisible": true,
					"template": "field/text-edit.html",
					"events": [],
					"class": "offset12"
				},
				{
					"id": "7781828071975223381266",
					"name": "ADMINEMAIL",
					"label": "Email",
					"showOnForm": true,
					"placeholder": null,
					"isReadOnly": false,
					"isVisible": true,
					"template": "field/text-edit.html",
					"events": [],
					"class": 13
				},
				{
					"id": "77818280724580481491267",
					"name": "ADMINPASSWORD",
					"showOnForm": true,
					"label": "Senha",
					"placeholder": null,
					"isReadOnly": false,
					"isVisible": true,
					"fieldGroup": "ADM",
					"template": "field/password-edit.html",
					"events": [],
					"class": 6
				},
				{
					"id": "77818280719675849091268",
					"name": "CONFIRMPASSWORD",
					"showOnForm": true,
					"label": "Confirmar senha",
					"placeholder": null,
					"isReadOnly": false,
					"sequenceInForm": 4,
					"isVisible": true,
					"fieldGroup": "ADM",
					"template": "field/password-edit.html",
					"events": [],
					"class": 6
				}
				]
			}
		]
	};

	var formContainer3 =	{
		"id": "154704342142507206061259",
		"name": "signupInit",
		"label": "Informações básicas",
		"showFooter": true,
		"showHeader": true,
		"showMenu": true,
		"showBack": true,
		"showForm": true,
		"footer": "component/footer.html",
		"template": "container/window.html",
		"events": [],
		"widgets": [
			{
				"id": "77818280732323444341260",
				"name": "signupInit",
				"label": "Cadastros",
				"template": "widget/form.html",
				"orderFieldsBySequenceInForm": true,
				"isVisible": true,
				"actions": [],
				"dataSource": {
					"rest": false,
					"localStorage": true,
					"name": "/signupInit",
					"data": []
				},
				"events": [
					{
						"id": "7781828079009969361269",
						"name": "WidgetOnEnter",
						"code": "SignupInitController.onEnter(args.owner)"
					}
				],
				"fieldGroups": [
					{
						"id": "77818280740425318131270",
						"name": "ORG",
						"label": "Dados da organização",
						"collapsible": true,
						"opened": true
					},
					{
						"id": "77818280735090805031271",
						"name": "ADM",
						"label": "Dados do administrador",
						"collapsible": true,
						"opened": true
					}
				],
				"fields": [
					{
						"id": "77818280734383929351262",
						"name": "CREATIONORG",
						"label": "Data de fundação",
						"sequenceInForm": 2,
						"showOnForm": true,
						"placeholder": null,
						"isReadOnly": false,
						"isVisible": true,
						"fieldGroup": "ORG",
						"template": "field/date.html",
						"events": [],
						"class": "col-sm-6"
					},
					{
						"id": "28627738307342929351818",
						"name": "GROUP",
						"label": "Field without field group",
						"sequenceInForm": 2,
						"showOnForm": true,
						"placeholder": null,
						"isReadOnly": false,
						"isVisible": true,
						"template": "field/date.html",
						"events": [],
						"class": "col-sm-6"
					},
					{
						"id": "7781828077321840201263",
						"name": "REGISTER",
						"label": "CPF/CNPJ",
						"sequenceInForm": 1,
						"placeholder": null,
						"showOnForm": true,
						"isReadOnly": false,
						"isVisible": true,
						"fieldGroup": "ORG",
						"template": "field/text-edit.html",
						"events": [],
						"class": "col-md-12"
					},
					{
						"id": "77818280717983132041264",
						"name": "ORGDESC",
						"label": "Descrição",
						"placeholder": null,
						"sequenceInForm": 3,
						"showOnForm": true,
						"isReadOnly": false,
						"isVisible": true,
						"fieldGroup": "ORG",
						"template": "field/textarea.html",
						"events": [],
						"class": "col-lg-12"
					},
					{
						"id": "77818280735347100081265",
						"name": "ADMINNAME",
						"label": "Nome",
						"placeholder": null,
						"isReadOnly": false,
						"showOnForm": true,
						"isVisible": true,
						"fieldGroup": "ADM",
						"sequenceInForm": 3,
						"template": "field/text-edit.html",
						"events": [],
						"class": "offset12"
					},
					{
						"id": "7781828071975223381266",
						"name": "ADMINEMAIL",
						"label": "Email",
						"showOnForm": true,
						"placeholder": null,
						"isReadOnly": false,
						"sequenceInForm": 2,
						"isVisible": true,
						"fieldGroup": "ADM",
						"template": "field/text-edit.html",
						"events": [],
						"class": 12
					},
					{
						"id": "77818280724580481491267",
						"name": "ADMINPASSWORD",
						"showOnForm": true,
						"label": "Senha",
						"placeholder": null,
						"sequenceInForm": 1,
						"isReadOnly": false,
						"isVisible": true,
						"fieldGroup": "ADM",
						"template": "field/password-edit.html",
						"events": [],
						"class": 6
					},
					{
						"id": "77818280719675849091268",
						"name": "CONFIRMPASSWORD",
						"showOnForm": true,
						"label": "Confirmar senha",
						"placeholder": null,
						"isReadOnly": false,
						"sequenceInForm": 4,
						"isVisible": true,
						"fieldGroup": "ADM",
						"template": "field/password-edit.html",
						"events": [],
						"class": 6
					}
				]
			}
		]
	};

	var formContainer4 = {
		"id": "154704342142507206061259",
		"name": "signupInit",
		"label": "Informações básicas",
		"showFooter": true,
		"showHeader": true,
		"showMenu": true,
		"showBack": true,
		"showForm": true,
		"footer": "component/footer.html",
		"template": "container/window.html",
		"events": [],
		"widgets": [
			{
				"id": "77818280732323444341260",
				"name": "signupInit",
				"label": "Cadastros",
				"template": "widget/form.html",
				"orderFieldsBySequenceInForm": true,
				"isVisible": true,
				"actions": [],
				"dataSource": {
					"rest": false,
					"localStorage": true,
					"name": "/signupInit",
					"data": []
				},
				"events": [
					{
						"id": "7781828079009969361269",
						"name": "WidgetOnEnter",
						"code": "SignupInitController.onEnter(args.owner)"
					}
				],
				"fieldGroups": [
					{
						"id": "77818280740425318131270",
						"name": "ORG",
						"label": "Dados da organização",
						"collapsible": true,
						"opened": true
					},
					{
						"id": "77818280735090805031271",
						"name": "ADM",
						"label": "Dados do administrador",
						"collapsible": true,
						"opened": true
					}
				],
				"fields": [
					{
						"id": "77818280734383929351262",
						"name": "CREATIONORG",
						"label": "Data de fundação",
						"sequenceInForm": 2,
						"showOnForm": true,
						"placeholder": null,
						"isReadOnly": false,
						"isVisible": true,
						"fieldGroup": "ORG",
						"template": "field/date.html",
						"events": [],
						"class": "col-sm-6"
					},
					{
						"id": "28627738307342929351818",
						"name": "GROUP",
						"label": "Field without field group",
						"sequenceInForm": 2,
						"showOnForm": true,
						"placeholder": null,
						"isReadOnly": false,
						"breakline": true,
						"isVisible": true,
						"template": "field/date.html",
						"events": [],
						"class": "col-sm-6"
					},
					{
						"id": "7781828077321840201263",
						"name": "REGISTER",
						"label": "CPF/CNPJ",
						"sequenceInForm": 1,
						"placeholder": null,
						"showOnForm": true,
						"isReadOnly": false,
						"isVisible": true,
						"fieldGroup": "ORG",
						"template": "field/text-edit.html",
						"events": [],
						"class": "col-md-12"
					},
					{
						"id": "77818280717983132041264",
						"name": "ORGDESC",
						"label": "Descrição",
						"placeholder": null,
						"sequenceInForm": 3,
						"showOnForm": true,
						"isReadOnly": false,
						"isVisible": true,
						"fieldGroup": "ORG",
						"template": "field/textarea.html",
						"events": [],
						"class": "col-lg-12"
					},
					{
						"id": "77818280735347100081265",
						"name": "ADMINNAME",
						"label": "Nome",
						"placeholder": null,
						"isReadOnly": false,
						"showOnForm": true,
						"isVisible": true,
						"fieldGroup": "ADM",
						"sequenceInForm": 3,
						"template": "field/text-edit.html",
						"events": [],
						"class": "offset12"
					},
					{
						"id": "7781828071975223381266",
						"name": "ADMINEMAIL",
						"label": "Email",
						"showOnForm": true,
						"placeholder": null,
						"isReadOnly": false,
						"sequenceInForm": 2,
						"isVisible": true,
						"fieldGroup": "ADM",
						"template": "field/text-edit.html",
						"events": [],
						"class": 12
					},
					{
						"id": "77818280724580481491267",
						"name": "ADMINPASSWORD",
						"showOnForm": true,
						"label": "Senha",
						"placeholder": null,
						"sequenceInForm": 1,
						"isReadOnly": false,
						"isVisible": true,
						"fieldGroup": "ADM",
						"template": "field/password-edit.html",
						"events": [],
						"class": 6
					},
					{
						"id": "77818280719675849091268",
						"name": "CONFIRMPASSWORD",
						"showOnForm": true,
						"label": "Confirmar senha",
						"placeholder": null,
						"isReadOnly": false,
						"sequenceInForm": 4,
						"isVisible": true,
						"fieldGroup": "ADM",
						"template": "field/password-edit.html",
						"events": [],
						"class": 6
					}
				]
			}
		]
	};

	it("Should order form's Fields ", function() {
		//No function is executed here because form constructor will alter the fields order
		expect(widget.fields[0].name).toEqual("REGISTER");
		expect(widget.fields[1].name).toEqual("ADMINPASSWORD");
		expect(widget.fields[2].name).toEqual("CREATIONORG");
		expect(widget.fields[3].name).toEqual("ADMINEMAIL");
		expect(widget.fields[4].name).toEqual("ORGDESC");
		expect(widget.fields[5].name).toEqual("ADMINNAME");
		expect(widget.fields[6].name).toEqual("CONFIRMPASSWORD");
	});

	it("Should redraw form widget with fields on correct FieldGroup", function(){
		widget.fields[0].fieldGroup = "ADM";
		widget.redraw();
		expect(widget.fields.filter(function(field){return field.fieldGroup =="ADM";}).length).toEqual(5);
		expect(widget.fields.filter(function(field){return field.fieldGroup =="ORG";}).length).toEqual(2);
	});

	it("Should redraw form widget with no fields", function(){
		widget.fields = [];
		widget.redraw();
		expect(widget.fields.filter(function(field){return field.fieldGroup =="ORG";}).length).toEqual(0);
		expect(widget.fields.filter(function(field){return field.fieldGroup =="ADM";}).length).toEqual(0);
	});

	it("Should redraw form widget with fieldGroups", function(){
		var container = metaDataFactory.containerFactory(formContainer2);
		scope.widget = container.widgets[0];
		var formController = new FormController(scope, eventEngine);
		widget = scope.widget;
		widget.redraw();
		expect(widget.fields.filter(function(field){return field.fieldGroup =="ORG";}).length).toEqual(0);
		expect(widget.fields.filter(function(field){return field.fieldGroup =="ADM";}).length).toEqual(2);
	});

	it("Should redraw form widget without fieldGroups", function(){
		delete formContainer2.widgets[0].fieldGroups;
		var container = metaDataFactory.containerFactory(formContainer2);
		scope.widget = container.widgets[0];
		var formController = new FormController(scope, eventEngine);
		widget = scope.widget;
		widget.redraw();
		expect(widget.fieldGroups.length).toEqual(1);
	});

	it("Test widget.template watch", function(){
			var container = metaDataFactory.containerFactory(formContainer2);
			scope.widget = container.widgets[0];
			widget = scope.widget;
			var formController = new FormController(scope, eventEngine);
			widget.edit();
			scope.$apply();
			expect(widget.fieldGroups.length).toEqual(1);
	});

	it("Test visible fields ssswatchCollection", function(){
		var container = metaDataFactory.containerFactory(formContainer2);
		scope.widget = container.widgets[0];
		widget = scope.widget;
		var formController = new FormController(scope, eventEngine);
		widget.fields[0].isVisible = false;
		widget.fields[4].isVisible = false;
		scope.$apply();
		expect(widget.fieldGroups.length).toEqual(1);
	});

	it("Test visible fields s watchCollection with showOnForm changes", function(){
		var container = metaDataFactory.containerFactory(formContainer2);
		scope.widget = container.widgets[0];
		widget = scope.widget;
		var formController = new FormController(scope, eventEngine);
		widget.fields[0].showOnForm = false;
		widget.fields[4].showOnForm = false;
		scope.$apply();
		expect(widget.fieldGroups.length).toEqual(1);
	});

	it("Should update flag poiting if field group have visible fields", function() {
		var container = metaDataFactory.containerFactory(formContainer);
		scope.widget = container.widgets[0];
		widget = scope.widget;
		var formController = new FormController(scope, eventEngine);

		widget.fields = widget.fields.map(function(field) {
			if (field.fieldGroup === 'ORG') {
				field.isVisible = false;
			}

			return field;
		});

		scope.$apply();
		expect(widget.fieldGroups[0]._hasVisibleFields).toEqual(false);
		expect(widget.fieldGroups[1]._hasVisibleFields).toEqual(true);
	});

	it("Should update flag poiting if field group have visible fields on fieldGroup for fields without group", function() {
		var container = metaDataFactory.containerFactory(formContainer3);
		scope.widget = container.widgets[0];
		widget = scope.widget;
		var formController = new FormController(scope, eventEngine);

		scope.$apply();
		expect(widget.fieldGroups[0].name).toBe(undefined);
		expect(widget.fieldGroups[0]._hasVisibleFields).toBe(true);
		expect(widget.fieldGroups[1].name).toBe('ORG');
		expect(widget.fieldGroups[1]._hasVisibleFields).toBe(true);
		expect(widget.fieldGroups[2].name).toBe('ADM');
		expect(widget.fieldGroups[2]._hasVisibleFields).toBe(true);
	});

	it("Should not create fieldGroup row without field", function() {
		var container = metaDataFactory.containerFactory(formContainer4);
		scope.widget = container.widgets[0];
		widget = scope.widget;
		var formController = new FormController(scope, eventEngine);

		scope.$apply();
		expect(widget.fieldGroups[0].name).toBe(undefined);
		expect(widget.fieldGroups[0]._hasVisibleFields).toBe(true);
		expect(widget.fieldGroups[0].rows.length).toBe(1);
		expect(widget.fieldGroups[0].rows[0].fields.length).toBe(1);

		expect(widget.fieldGroups[1].name).toBe('ORG');
		expect(widget.fieldGroups[1]._hasVisibleFields).toBe(true);
		expect(widget.fieldGroups[1].rows.length).toBe(1);
		expect(widget.fieldGroups[1].rows[0].fields.length).toBe(3);

		expect(widget.fieldGroups[2].name).toBe('ADM');
		expect(widget.fieldGroups[2]._hasVisibleFields).toBe(true);
		expect(widget.fieldGroups[2].rows.length).toBe(3);
		expect(widget.fieldGroups[2].rows[0].fields.length).toBe(1);
		expect(widget.fieldGroups[2].rows[1].fields.length).toBe(2);
		expect(widget.fieldGroups[2].rows[2].fields.length).toBe(1);
	});

	describe("Row sizes form controller tests", function(){
		var windowSizeBkp = window.innerWidth;

		afterEach(function() {
			window.innerWidth = windowSizeBkp;
		});


		it("Teste field size on form with window >= 1200", function(){
			window.innerWidth = 1200;
			widget.redraw();
			expect(widget.fieldGroups[0].rows.length).toEqual(3);
			expect(widget.fieldGroups[1].rows.length).toEqual(3);
		});

		it("Teste field size on form with window >= 992", function(){
			window.innerWidth = 993;
			widget.redraw();
			expect(widget.fieldGroups[0].rows.length).toEqual(2);
			expect(widget.fieldGroups[0].rows.length).toEqual(2);
		});

		it("Teste field size on form with window >= 768", function(){
			window.innerWidth = 769;
			widget.redraw();
			expect(widget.fieldGroups[0].rows.length).toEqual(1);
			expect(widget.fieldGroups[0].rows.length).toEqual(1);
		});


	});

});