function Environment(localStorageEngine, RestEngine) {
    
    var self = this;    
    var ENVIRONMENT_KDS_FLAG = 'ENVIRONMENT_KDS';
    var ENVIRONMENT_LOCAL_ID = 'LOCAL_ID';

    self.projectConfig = null;
    self.kdsWidget = null;

	let localID = localStorage.getItem(ENVIRONMENT_LOCAL_ID);
	if (localID) {
		window.localID = localID;
		localStorage.removeItem(ENVIRONMENT_LOCAL_ID);
		ENVIRONMENT_KDS_FLAG = ENVIRONMENT_KDS_FLAG + window.localID;
	}

	window.changeLocalEnvironment = function () {
		if (window.localID) {
			let oldValue = localStorageEngine.getLocalVar(ENVIRONMENT_KDS_FLAG);
			ENVIRONMENT_KDS_FLAG = ENVIRONMENT_KDS_FLAG + window.localID;
			localStorageEngine.setLocalVar(ENVIRONMENT_KDS_FLAG, oldValue);	
		}
	};

    window.customKDSReload = function () {
        if (!window.localID) {
            location.reload();
        } else {
			let savedID = localStorage.getItem(ENVIRONMENT_LOCAL_ID);
			if (savedID && (savedID != window.localID)) {
				setTimeout(() => {
					window.customKDSReload();
				}, 1000);
			} else {
				localStorage.setItem(ENVIRONMENT_LOCAL_ID, window.localID);
				location.reload();
			}
			
        }
    };

    this.setKDSWidgetOnEnvironment = function(widget) {
        self.kdsWidget = widget;
    };

    this.getKDSWidget = function() {
        return self.kdsWidget;
    };
	
    this.setLocalEnvironment = function(localEnvironment) {
    	localEnvironment = JSON.stringify(localEnvironment);
        localStorageEngine.setLocalVar(ENVIRONMENT_KDS_FLAG, localEnvironment);
    };
    
	this.getLocalEnvironment = function() {
		var localEnvironment = localStorageEngine.getLocalVar(ENVIRONMENT_KDS_FLAG);
		if(localEnvironment) {
	    	return JSON.parse(localEnvironment);
		}
	};

    this.setProjectConfig = function() {
        return RestEngine.requestMetaData('config.json').then(function(configJSONData) {
            self.projectConfig = configJSONData.data;
            return configJSONData.data;
        });
    };

    this.getProjectConfig = function() {
        return self.projectConfig;
    };

    this.unsetLocalEnvironment = function() {
        localStorage.removeItem(ENVIRONMENT_KDS_FLAG);
    };

	this.getBranch = function(){
        var params = {
            requestType: "DataSet",
            dataset: {}
        };
        var getBranchRoute = '/branch/get';
        return RestEngine.post(getBranchRoute, params).then(function(response) {
            return response.dataset.branch;
        });
    };

    this.getBranchSectors = function(){
        var params = {
            requestType: "DataSet",
            dataset: {}
        };
        var getBranchSectorsRoute = '/sector/get';
        return RestEngine.post(getBranchSectorsRoute, params).then(function(response) {
            return response.dataset.sectors;
        });
    };

    this.getRegisterControlParams = function(CDSETOR){
        var params = {
            requestType: "Row",
            row: {
                'CDSETOR': CDSETOR
            }
        };
        var getControlParametersRoute = '/register/getControlParameters';
        return RestEngine.post(getControlParametersRoute, params).then(function(response) {
            return response.dataset.productionControlParams;
        });
    };
}

Configuration(function(ContextRegister) {
	ContextRegister.register('environment', Environment);
});